HanMacWrdJParser Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
HanMacWrdJParser Class Reference

the main class to read a HanMac Word-J file More...

`#include <HanMacWrdJParser.hxx>`

Inheritance diagram for HanMacWrdJParser:

## Public Member Functions
| HanMacWrdJParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~HanMacWrdJParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWTextParser
virtual | ~MWAWTextParser ()
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones in a Hapanese File More...
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
void | newPage (int number)
| adds a new page More...
bool | sendText (long id, long cPos, MWAWListenerPtr listener=MWAWListenerPtr())
| send a text zone More...
bool | canSendTextAsGraphic (long id, long cPos)
| check if we can send a textzone as graphic More...
bool | sendZone (long zId)
| send a zone More...
bool | getColor (int colId, int patternId, MWAWColor &color) const
| returns the color associated with a pattern More...
bool | checkEntry (MWAWEntry &entry)
| look in entry.begin() to see if a entry exists at this position, if so fills entry.end(), entry.id(), ... More...
bool | readZonesList ()
| try to read the zones list More...
bool | readZone (MWAWEntry &entry)
| try to read a generic zone More...
bool | readClassicHeader (HanMacWrdJZoneHeader &header, long endPos=-1)
| try to read a header of classic zone More...
bool | decodeZone (MWAWEntry const &entry, librevenge::RVNGBinaryData &data)
| try to decode a zone More...
bool | readPrintInfo (MWAWEntry const &entry)
| try to read a printinfo zone More...
bool | readHeaderEnd ()
| try to read a unknown zone, just after the header (simillar to HanMacWrd Zoneb) More...
bool | readZoneA (MWAWEntry const &entry)
| try to read the zone A ( a big zone containing 5 sub zone ? ) More...
bool | readZoneB (MWAWEntry const &entry)
| try to read the zone B More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
shared_ptr< HanMacWrdJParserInternal::State > | m_state
| the state More...
shared_ptr< HanMacWrdJGraph > | m_graphParser
| the graph parser More...
shared_ptr< HanMacWrdJText > | m_textParser
| the text parser More...

## Friends
class | HanMacWrdJGraph
class | HanMacWrdJText
class | HanMacWrdJParserInternal::SubDocument

## Detailed Description

the main class to read a HanMac Word-J file

## Constructor & Destructor Documentation

HanMacWrdJParser::HanMacWrdJParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

HanMacWrdJParser::~HanMacWrdJParser | ( |  | ) |
| virtual

destructor

## Member Function Documentation

bool HanMacWrdJParser::canSendTextAsGraphic | ( | long | id,
|  | long | cPos
| ) |  |
| protected

check if we can send a textzone as graphic

Referenced by HanMacWrdJGraph::canCreateGraphic(), HanMacWrdJGraph::sendFrame(), and HanMacWrdJGraph::sendGroupChild().

bool HanMacWrdJParser::checkEntry | ( | MWAWEntry & | entry | ) |
| protected

look in entry.begin() to see if a entry exists at this position, if so fills entry.end(), entry.id(), ...

Referenced by createZones(), and readZonesList().

bool HanMacWrdJParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void HanMacWrdJParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

bool HanMacWrdJParser::createZones | ( |  | ) |
| protected

finds the different objects zones in a Hapanese File

Referenced by parse().

bool HanMacWrdJParser::decodeZone | ( | MWAWEntry const & | entry,
|  | librevenge::RVNGBinaryData & | data
| ) |  |
| protected

try to decode a zone

Referenced by HanMacWrdJText::computeNumPages(), and HanMacWrdJText::sendText().

bool HanMacWrdJParser::getColor | ( | int | colId,
|  | int | patternId,
|  | MWAWColor & | color
| ) |  | const
| protected

returns the color associated with a pattern

Referenced by HanMacWrdJText::readFont(), and HanMacWrdJText::readParagraph().

MWAWVec2f HanMacWrdJParser::getPageLeftTop | ( |  | ) | const
| protected

returns the page left top point ( in inches)

void HanMacWrdJParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by HanMacWrdJParser().

void HanMacWrdJParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by HanMacWrdJText::sendText().

void HanMacWrdJParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| virtual

virtual function used to parse the input

Implements MWAWTextParser.

bool HanMacWrdJParser::readClassicHeader | ( | HanMacWrdJZoneHeader & | header,
|  | long | endPos = `-1`
| ) |  |
| protected

try to read a header of classic zone

Referenced by HanMacWrdJText::readFonts(), HanMacWrdJGraph::readFrames(), HanMacWrdJText::readFtnPos(), HanMacWrdJGraph::readGraphData(), HanMacWrdJGraph::readGroupData(), readHeaderEnd(), HanMacWrdJText::readParagraphs(), HanMacWrdJText::readSections(), HanMacWrdJText::readStyles(), HanMacWrdJGraph::readTable(), HanMacWrdJGraph::readTableFormatsList(), HanMacWrdJText::readTextToken(), HanMacWrdJText::readTextZone(), HanMacWrdJText::readTextZonesList(), readZoneA(), and readZoneB().

bool HanMacWrdJParser::readHeaderEnd | ( |  | ) |
| protected

try to read a unknown zone, just after the header (simillar to HanMacWrd Zoneb)

Referenced by createZones().

bool HanMacWrdJParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |
| protected

try to read a printinfo zone

Referenced by checkHeader().

bool HanMacWrdJParser::readZone | ( | MWAWEntry & | entry | ) |
| protected

try to read a generic zone

Referenced by createZones().

bool HanMacWrdJParser::readZoneA | ( | MWAWEntry const & | entry | ) |
| protected

try to read the zone A ( a big zone containing 5 sub zone ? )

Referenced by readZone().

bool HanMacWrdJParser::readZoneB | ( | MWAWEntry const & | entry | ) |
| protected

try to read the zone B

Referenced by readZone().

bool HanMacWrdJParser::readZonesList | ( |  | ) |
| protected

try to read the zones list

Referenced by createZones().

bool HanMacWrdJParser::sendText | ( | long | id,
|  | long | cPos,
|  | MWAWListenerPtr | listener = `MWAWListenerPtr()`
| ) |  |
| protected

send a text zone

Referenced by HanMacWrdJParserInternal::SubDocument::parse(), and HanMacWrdJGraph::sendText().

bool HanMacWrdJParser::sendZone | ( | long | zId | ) |
| protected

send a zone

Referenced by HanMacWrdJText::sendText().

## Friends And Related Function Documentation

friend class HanMacWrdJGraph
| friend

Referenced by init().

friend class HanMacWrdJParserInternal::SubDocument
| friend

friend class HanMacWrdJText
| friend

Referenced by init().

## Member Data Documentation

shared_ptr<HanMacWrdJGraph> HanMacWrdJParser::m_graphParser
| protected

the graph parser

Referenced by createDocument(), createZones(), getColor(), init(), parse(), readZone(), and sendZone().

shared_ptr<HanMacWrdJParserInternal::State> HanMacWrdJParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), getPageLeftTop(), init(), newPage(), readZone(), and readZonesList().

shared_ptr<HanMacWrdJText> HanMacWrdJParser::m_textParser
| protected

the text parser

Referenced by canSendTextAsGraphic(), createDocument(), createZones(), init(), parse(), readZone(), and sendText().

The documentation for this class was generated from the following files:

- HanMacWrdJParser.hxx
- HanMacWrdJParser.cxx